Random123-1.09: r123::Threefry2x64_R< R > Class Template Reference

- Random123-1.09 Documentation

Public Types | Public Member Functions | Static Public Attributes

# r123::Threefry2x64_R< R > Class Template Reference
[Threefry Classes and Typedefs]

`#include <Random123/threefry.h>`

List of all members.

## Public Types
typedef threefry2x64_ctr_t | ctr_type
typedef threefry2x64_key_t | key_type
typedef threefry2x64_key_t | ukey_type
## Public Member Functions
ctr_type | operator() (ctr_type ctr, key_type key)
## Static Public Attributes
static const unsigned int | rounds = R

## Detailed Description

### template<unsigned int R>
class r123::Threefry2x64_R< R >

exports the member functions, typedefs and operator overloads required by a CBRNG class.

The template argument, ROUNDS, is the number of times the Threefry round function will be applied.

In November 2011, the authors discovered that 13 rounds of Threefry2x64 sequenced by strided, interleaved key and counter increments failed a very long (longer than the default BigCrush length) WeightDistrub test. At the same time, it was confirmed that 14 rounds passes much longer tests (up to 5x10^12 samples) of a similar nature. The authors know of no statistical flaws with ROUNDS=14 or more for Threefry2x64.

## Member Typedef Documentation

template<unsigned int R>

typedef threefry2x64_ctr_t r123::Threefry2x64_R< R >::ctr_type

template<unsigned int R>

typedef threefry2x64_key_t r123::Threefry2x64_R< R >::key_type

template<unsigned int R>

typedef threefry2x64_key_t r123::Threefry2x64_R< R >::ukey_type

## Member Function Documentation

template<unsigned int R>

ctr_type r123::Threefry2x64_R< R >::operator() | ( | ctr_type | ctr,
|  | key_type | key |
| ) |  |  | `[inline]`

## Member Data Documentation

template<unsigned int R>

const unsigned int r123::Threefry2x64_R< R >::rounds = R`[static]`

The documentation for this class was generated from the following file:

- Random123/threefry.h

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines